<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE>JFLAP: Mealy Machine Examples</TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 1.1.5  (Linux)">
	<META NAME="CREATED" CONTENT="20070710;16045600">
	<META NAME="CHANGED" CONTENT="20070710;16195700">
	<!--@author Jinghui Lim-->
</HEAD>
<BODY LANG="en-US" DIR="LTR">
<H1>Mealy Machine Examples</H1>
<H2>Contents</H2>
<P><A HREF="mealyMachines.html">Back to Mealy Machines</A><BR><A HREF="#ex1">Example
1: NOT</A><BR><A HREF="#ex2">Example 2: Vending Machine</A></P>
<H2><A NAME="ex1"></A>Example 1: NOT</H2>
<P>Let's start with a simple Mealy machine that takes an input bit
string <I>b</I> and produces the output NOT(<I>b</I>).</P>
<P>The machine should look like this, and can be downloaded through
<A HREF="files/mealyNOT.jff">mealyNOT.jff</A>: 
</P>
<P ALIGN=CENTER><IMG SRC="images/mealyNOT.png" NAME="Graphic1" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>A Mealy machine that produces NOT(<I>b</I>) 
</P>
<P>As you can see, the initial state has two outgoing transitions,
one for the input &quot;0&quot; that produces the output &quot;1&quot;,
and one for the input &quot;1&quot; that produces the output &quot;0&quot;.
Thus, for every bit <I>b<SUB>i</SUB></I> of the input, this machine
produces the output NOT(<I>b<SUB>i</SUB></I>), and takes the
transition back to the same state so it may similarly process the
next bit of the input. 
</P>
<P>Let's step the machine through the input &quot;101&quot;. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mealyEx1Step0.png" NAME="Graphic2" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Initial set up 
</P>
<P>The machine is in its initial, and only, state, <I>q</I><SUB>0</SUB>.
The two outgoing transitions from <I>q</I><SUB>0</SUB> each produce
the negation of the input bit. Click <B>Step</B> to process the next
bit of the input. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mealyEx1Step1.png" NAME="Graphic3" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Step 1 
</P>
<P>Upon processing the first bit of the input, &quot;1&quot;, the
machine takes the transition <I>1</I> ; <I>0</I>, producing the
output &quot;0&quot;, which is the negation of the input bit. This
transition takes the machine back to its only state, <I>q</I><SUB>0</SUB>.
Click <B>Step</B> to process the next bit of input. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mealyEx1Step2.png" NAME="Graphic4" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Step 2 
</P>
<P>Upon processing the next bit of the input, &quot;0&quot;, the
machine takes the transition <I>0</I> ; <I>1</I>, producing the
output &quot;1&quot;, which is the negation of the input bit. This
transition takes the machine back to <I>q</I><SUB>0</SUB>. We have
seen that state <I>q</I><SUB>0</SUB> properly processes both input
bit &quot;0&quot; and &quot;1&quot;, and returns the machine to <I>q</I><SUB>0</SUB>,
showing that the machine will properly process any input bit. Click
<B>Step</B> to complete the process. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mealyEx1Step3.png" NAME="Graphic5" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Step 3 
</P>
<P>As we can see, the machine indeed produces the negation of its
input bit string. 
</P>
<P>We can also test this machine on multiple strings. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mealyMultipleRun.png" NAME="Graphic6" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Testing the machine on multiple strings 
</P>
<P>As you can see, it produces NOT(<I>b</I>) in every instance. 
</P>
<P>You can download the file <A HREF="files/mealyNOT.jff">here</A> to
try it out. 
</P>
<H2><A NAME="ex2"></A>Example 2: Vending Machine</H2>
<P>(Example adapted from <I>Theory of Finite Automata with an
Introduction to Formal LanguagesK</I> by John Carroll and Darrell
Long.) 
</P>
<P>Next, let's consider a more complex machine. We shall build a
vending machine that dispenses one piece of candy once enough money
has been inserted, and returns the appropriate amount of change.  (To
see a completed version, feel free to download  <A HREF="files/mealyVending.jff">mealyVending.jff</A>.)</P>
<P>Let <I>V</I> = ({0<I>c</I>, 5<I>c</I>, 10<I>c</I>, 15<I>c</I>},
{<I>n</I>, <I>d</I>, <I>q</I>}, {<I>c</I><SUB>0</SUB>, <I>c</I><SUB>1</SUB>,
<I>c</I><SUB>2</SUB>, <I>c</I><SUB>3</SUB>, <I>c</I><SUB>4</SUB>},
δ<!--small delta-->, ω<!--small omega-->, 0<I>c</I>}. (See the
Mealy machine <A HREF="mealyMachines.html#definition">definition</A>.)
<I>V</I> describes a vending machine that dispenses 20&cent;<!--cent-->
candy bars. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mealyVending.png" NAME="Graphic7" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Mealy machine <I>V</I> 
</P>
<P>This Mealy machine has four states, 0<I>c</I>, 5<I>c</I>, 10<I>c</I>,
and 15<I>c</I>, each describing the amount of money inserted in the
vending machine, 0&cent;, 5&cent;, 10&cent;, and 15&cent;. Its input
alphabet of <I>n</I>, <I>d</I>, and <I>q</I>, denotes the insertion
of nickels, dimes, and quarters respectively. In its output alphabet,
λ<!--lambda--> denotes the vending machine doing nothing, while <I>c</I><SUB>0</SUB>,
<I>c</I><SUB>1</SUB>, <I>c</I><SUB>2</SUB>, <I>c</I><SUB>3</SUB>, and
<I>c</I><SUB>4</SUB>, denote the machine dispensing candy and no,
one, two, three and four nickels respectively as change. 
</P>
<P>Let's step through the input <I>ndq</I>. (That is, someone
inserted a nickel, a dime, followed by a quarter.) 
</P>
<P ALIGN=CENTER><IMG SRC="images/mealyEx2Step0.png" NAME="Graphic8" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>No coins inserted 
</P>
<P>The machine starts at 0<I>c</I>, as it has not had any money
inserted yet. Click <B>Step</B> to insert the first nickel. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mealyEx2Step1.png" NAME="Graphic9" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>First coin (a nickel) inserted 
</P>
<P>The machine takes the transition <I>n</I> ; λ from 0<I>c</I> to
5<I>c</I>, denoting that 5&cent; has been inserted. The transition
produces no output as not enough money has been inserted. Click <B>Step</B>
to insert the next coin, a dime. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mealyEx2Step2.png" NAME="Graphic10" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Second coin (a dime) inserted 
</P>
<P>The machine takes the transition <I>d</I> ; λ from 5<I>c</I> to
15<I>c</I>, indicating that 15&cent; has been accumulated. Again, the
transition produces no output as not enough money has been inserted.
Click <B>Step</B> to insert the last coin, a quarter. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mealyEx2Step3.png" NAME="Graphic11" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Last coin (a quarter) inserted 
</P>
<P>The machine takes the transition <I>q</I> ; <I>c</I><SUB>4</SUB>
from 15<I>c</I> to 0<I>c</I>, back to the initial state. The
transition produces output <I>c</I><SUB>4</SUB>, and the vending
machine dispenses a piece of candy and four nickels. Thus, once it
has accumulated sufficient money, it dispenses a piece of candy and
the correct amount of change, just as we have <A HREF="#ex2">described</A>.
</P>
<P>Let's try our vending machine out on different sets of change. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mealyEx2MultipleRun.png" NAME="Graphic12" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Running the vending machine on different sets of
coins 
</P>
<P>As you can see, each time our vending machine accumulates
sufficient money, it dispenses a piece of candy and the appropriate
amount of change. The last two inputs, <I>dd</I> and <I>ddn</I>,
although different, produce the same output <I>c</I><SUB>0</SUB>.
This is because they end in different states. Effectively, for input
<I>ddn</I> the vending machine still has 5&cent; in it. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mealyEx2Trace1.png" NAME="Graphic13" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>The trace for input <I>dd</I> 
</P>
<P>For input <I>dd</I>, the state we end in is 0<I>c</I>, indicating
there is no extra change in the vending machine. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mealyEx2Trace2.png" NAME="Graphic14" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>The trace for input <I>ddn</I> 
</P>
<P>For input <I>ddn</I>, the state we end in is 5<I>c</I>, indicating
that we still have 5&cent; of change in it. 
</P>
</BODY>
</HTML>
